<?php
//YANMAH2 - Yet ANother Mobile Accelerated HatenaHaiku
//(c) 2010 YANMAH2 project
//This program is freesoftware. you can redistribute it and/ormodify it under the terms of the [GNU Affero GPL v3](http://www.gnu.org/licenses/agpl.html).
?>
<?php
define("HELLO","world");
require_once "product_definitions.php";
require_once "configurable_variables.php";
?>
<?php
ini_set('session.gc_maxlifetime', $session_file_lifetime);
if ($session_gc_prob[0] != 'default') ini_set('session.gc_probability', $session_gc_prob[0]);
if ($session_gc_prob[1] != 'default') ini_set('session.gc_divisor', $session_gc_prob[1]);
ini_set('session.use_trans_sid', 0);
session_set_cookie_params($session_cookie_expire, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
if ($custom_session_save_path != 'default'){
	session_save_path($custom_session_save_path);
}
session_cache_limiter('public');
session_cache_expire(1);
session_start();
if ($_SESSION['auth'] != TRUE){
// if ($_SESSION['image'] != 'on'){
  $_SESSION = array();
  if (isset($_COOKIE[session_name()])){
	setcookie(session_name(), '', time() - 42000, dirname($_SERVER['SCRIPT_NAME']) . '/', $_SERVER["SERVER_NAME"]);
  }
  session_destroy();
// }
}
//session_regenerate_id(TRUE);
?>
<?php
if ($extra_include_path != "default"){
	$default_include_path = ini_get("include_path");
	ini_set('include_path', ".:{$extra_include_path}:{$default_include_path}");
}
$selfcall = htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES);
$safequery = htmlspecialchars($_SERVER["QUERY_STRING"], ENT_QUOTES);
$http_url_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]+';
$http_host_regexp = 's?https?:\/\/[-_.!~*\'()a-zA-Z0-9;?:@&=+$,%#]+\/*';
$http_path_regexp = '[-_.!~*\'()a-zA-Z0-9;\/?:@&=+$,%#]*';
mb_regex_encoding("UTF-8");
?>
<?php
//NULL バイトの入力を弾く
function checkNull($array){
	if (is_array($array)){
		return array_map('checkNull', $array);
	}
	if (preg_match('/\0/', $array)){
		echo "NULL ぽ";
		exit();
	}
}
checkNull($_GET);
//長すぎる検索ワード
function checkWord($element){
	if (strlen(bin2hex($element)) > 511){
		echo "キーワードが長すぎて入らないです…\n(YANMAH2: キーワードの指定に関するエラー)";
		exit();
	}
}
if ($_GET["word"] != ''){
	checkWord($_GET["word"]);
}
//不正なはてなID
//正しいはてなID＝アルファベットで始まり、アルファベットか数字で終わる3文字以上､32文字以内の半角英数字
function checkId($element){
	if (preg_match("/^[a-zA-Z]{1}[-_a-zA-Z1234567890]{1,30}[a-zA-Z1234567890]{1}$/u" ,$element) == 0){
		echo "なにそれこわい\n(YANMAH2: はてなIDの指定に関するエラー)";
		exit();
	}
}
if ($_GET["user"] != ''){
	checkId($_GET["user"]);
}
//不正な page
//page=n は100までの数値であること。
function checkPagenum($element){
	if (preg_match("/^[1234567890]{1,3}$/u",$element) == 0){
		echo "数字以外入れちゃだめ\n(YANMAH2: ページ数に関するエラー)";
		exit();
	}
	if ($element > 100){
		echo "ページ数が大きすぎで…\n(YANMAH2: ページ数に関するエラー)";
		exit();
	}
}
if ($_GET[page] != ''){
	checkPagenum($_GET[page]);
}
?>
<?php
if ($_GET['word'] != ''){
	$get_word = $_GET['word'];
	$json_url = 'http://h.hatena.ne.jp/api/keywords/list.json?word=' . rawurlencode($get_word);
	$page_head = htmlspecialchars($get_word, ENT_QUOTES) . ' に一致するキーワード';
	$self_anchor = './keywords.php?word=' . rawurlencode(htmlspecialchars($get_word, ENT_QUOTES));
	$list_mode = 'search';
}	elseif ($_GET['user'] != ''){
		$get_user = $_GET['user'];
		$json_url = 'http://h.hatena.ne.jp/api/statuses/keywords/' . $get_user . '.json';
		$page_head = htmlspecialchars($get_user, ENT_QUOTES) . ' のお気に入りキーワード';
		$self_anchor = './keywords.php?user=' . $get_user;
		$list_mode = 'following';
}	else {
		$json_url = 'http://h.hatena.ne.jp/api/keywords/list.json';
		$page_head = 'キーワード一覧';
		$self_anchor = './keywords.php';
		$list_mode = 'default';
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
   "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
	<meta http-equiv="Content-Style-Type" content="text/css" />
	<meta http-equiv="Content-Script-Type" content="text/javascript" />
	<?php echo "<title>{$page_head} - {$site_name}{$site_name_caption}</title>\n"; ?>
	<link rel="stylesheet" href="<?php echo $style_sheet; ?>" />
	<link rel="icon" href="./favicon.ico" type="image/vnd.microsoft.icon" />
	<link rel="shortcut icon" href="./favicon.ico" type="image/vnd.microsoft.icon" /></head>
<body>
<?php
//var_dump($_GET);
echo "<div id=\"header\" class=\"keywords\">\n";
echo "<h1 id=\"entries-head\" class=\"head1\">{$page_head}</h1>\n<hr />";
echo "</div>\n";
?>
<div class="contents">
<ul>
<li><form method="get" action="./keywords.php" accept-charset="UTF-8">
<label for="go2keyword">キーワード</label><input type="text" name="word" maxlength="170" id="go2keyword" /><label for="go2keyword">を</label>
<?php if ($_GET['image'] == 'on') echo '<input type="hidden" name="image" value="on" />'; ?>
<input type="submit" value="検索" />
</form></li>
<?php
if ($_GET["page"] != ''){
	if ($get_word != ''){
		$request_url = $json_url . "&page=" . htmlspecialchars($_GET["page"], ENT_QUOTES);
	}	elseif ($get_user != ''){
			$request_url = $json_url . "?page=" . htmlspecialchars($_GET["page"], ENT_QUOTES);
	}	else {
			$request_url = $json_url . '?page=' . htmlspecialchars($_GET['page'], ENT_QUOTES);
	}
}	else {
	$request_url = $json_url;
}
//var_dump($request_url);
if ($kw_cache_dir == ''){
  $use_cache = FALSE;
} elseif (isset($_GET['reload']) && $_GET['reload'] == 'force'){
	$use_cache = 'force';
} elseif ($kw_cache_dir != ''){
	$use_cache = TRUE;
} else {
	$use_cache = FALSE;
}
require_once 'keywords_processor.php';
?>
</ul><hr />
</div>
<div>
<ul class="navigation-menu">
<?php
if ($_GET[page] != ''){
	if ($_GET[page] >= 100){
		$next_query = preg_replace('/page=[0123456789]{1,3}/u',"page=1",$safequery);
		$next_url = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?$next_query";
		$next_num = 1;
	}	else {
			$next_num = $_GET[page] + 1;
			$next_query = preg_replace('/page=[0123456789]{1,3}/u',"page={$next_num}",$_SERVER["QUERY_STRING"]);
			$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . htmlspecialchars($next_query, ENT_QUOTES);
		}
}	elseif ($_SERVER["QUERY_STRING"] != ""){
		$next_num = 2;
		$next_query = $_SERVER["QUERY_STRING"] . "&page=" . $next_num;
		$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . htmlspecialchars($next_query, ENT_QUOTES);
}	else {
		$next_num = 2;
		$next_query = "page=" . $next_num;
		$next_url = "http://" . $_SERVER["SERVER_NAME"] . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $next_query;
}
if ($next_num == 1){
	$current_page = 100;
} else {
	$current_page = $next_num - 1;
}
if ($_GET['page'] != ''){
	if ($_GET['page'] <= 1){
		$prev_query = preg_replace('/page=[0123456789]{1,3}/u',"page=100",$safequery);
		$prev_url = "http://{$_SERVER["SERVER_NAME"]}{$selfcall}?$prev_query";
		$prev_num = 100;
	} else {
		$prev_num = $_GET['page'] - 1;
		$prev_query = preg_replace('/page=[0123456789]{1,3}/u',"page={$prev_num}",$_SERVER["QUERY_STRING"]);
		$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
	}
} elseif ($_SERVER['QUERY_STRING'] != ''){
	$prev_num = 100;
	$prev_query = $safequery . '&amp;page=' . $prev_num;
	$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
} else {
	$prev_num = 100;
	$prev_query = 'page=' . $prev_num;
	$prev_url = "http://{$_SERVER['SERVER_NAME']}" . htmlspecialchars($_SERVER["PHP_SELF"], ENT_QUOTES) . "?" . $prev_query;
}
?>
<?php
if ($_GET['image'] != ''){
	$qimagemode = '?image=' . $_GET['image'];
} else {
	$qimagemode = '';
}
$to_entries = './entries.php';
$to_index = './index.php';
$to_keywords = './keywords.php';
if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on'){
  $to_entries = $to_entries.'?image=on';
  $to_index = $to_index.'?image=on';
}

echo "<li>この頁は " . $current_page . " ページ</li>";

echo "<li>";
echo "[1]<a href=\"{$self_anchor}";
if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on'){
  if ($list_mode == 'default'){
	echo '?image=on';
  } else {
	echo '&amp;image=on';
  }
}
echo "\" class=\"navigation-link\" accesskey=\"1\">最初の頁</a> ";
echo "[2]<a href=\"{$to_entries}\" class=\"navigation-link\" accesskey=\"2\">Entries</a> ";
echo "[3]<a href=\"mailto:?subject=" . htmlspecialchars($_GET["keyword"], ENT_QUOTES) . "\" class=\"navigation-link\" accesskey=\"3\">メール</a></li>";

echo "<li>";
echo "[4]<a href=\"{$prev_url}\" class=\"navigation-link\" accesskey=\"4\" rel=\"nofollow\">前へ(p{$prev_num})</a> ";
if ($list_mode == 'default'){
	echo "[5]<a href=\"{$self_anchor}?reload=force";
	if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on') echo '?image=on';
	echo "\" class=\"navigation-link\" accesskey=\"5\" rel=\"nofollow\">一覧更新</a>";
} else {
	echo "[5]<a href=\"{$self_anchor}&amp;reload=force";
	if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on') echo '?image=on';
	echo "\" class=\"navigation-link\" accesskey=\"5\" rel=\"nofollow\">一覧更新</a>";
}
echo "[6]<a href=\"{$next_url}\" class=\"navigation-link\" accesskey=\"6\" rel=\"nofollow\">次へ(p{$next_num})</a></li>";
echo '<li>';

if ($_SESSION['auth'] === TRUE){
	echo "[7]<a href=\"./keywords.php?user={$_SESSION['hatenaid']}";
	if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on') echo '&amp;image=on';
	echo "\" class=\"navigation-link\" accesskey=\"7\">Keywords</a> ";
	echo "[8]<a href=\"./entries.php?following={$_SESSION['hatenaid']}";
	if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on') echo '&amp;image=on';
	echo "\" class=\"navigation-link\" accesskey=\"8\">アンテナ</a> ";
} else {
	echo '[7]<a href="'.$to_keywords;
	if ($_GET['image'] == 'on' || $_SESSION['image'] == 'on') echo '?image=on';
	echo '" class="navigation-link" accesskey="7">Keywords</a>';
	echo '[8]&nbsp;-&nbsp;-&nbsp;-&nbsp;- ';
}
	echo '[9]<a href="'.$to_index.'" class="navigation-link" accesskey="9">トップ</a>';
echo '</li>';

echo '<li>';
if ($_SESSION['auth'] === TRUE){
	echo '[-]<a href="./login.php?log=out';
	if ($_SESSION['image'] == 'on') echo '&amp;image=on';
	echo '" class="navigation-link">ログアウト</a>';
} elseif ($_GET['image'] == 'on'){
	echo '[0]<a href="./login.php?return=' . rawurlencode($self_anchor_possibly_with_pagenum) . '&amp;image=on" class="navigation-link" accesskey="0">ログイン</a>';
} else {
	echo '[0]<a href="./login.php?return=' . rawurlencode($self_anchor_possibly_with_pagenum) . '" class="navigation-link" accesskey="0">ログイン</a>';
}
echo '</li>'."\n";
?>
</ul>
</div><hr />
<?php echo $footer; ?>
</body>
</html>
